#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Odds2_HitCoefficient.h"
std::auto_ptr<Odds2_HitCoefficient> Odds2_HitCoefficient::msSingleton(nullptr);

int Odds2_HitCoefficient::GetCount()
{
	return (int)mMapData.size();
}

const Odds2_HitCoefficientData* Odds2_HitCoefficient::GetData(int BuffID)
{
	auto it = mMapData.find(BuffID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Odds2_HitCoefficientData>& Odds2_HitCoefficient::GetMapData()
{
	return mMapData;
}

void Odds2_HitCoefficient::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Odds2_HitCoefficient.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Odds2_HitCoefficientData data;
		data.mBuffID = element->IntAttribute("BuffID");
		data.mCaptureNumber = element->IntAttribute("CaptureNumber");
		data.mBuffEffectMin = element->IntAttribute("BuffEffectMin");
		{
			const char* BossId = element->Attribute("BossId");
			std::vector<std::string> vecBossId;
			boost::split(vecBossId, BossId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecBossId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecBossId[i].c_str(), &temp))
				{
					data.mBossId.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mBuffID) != mMapData.end())std::cout <<"data refind:" << data.mBuffID << std::endl;
		CCASSERT(mMapData.find(data.mBuffID) == mMapData.end(), "data.mBuffID is exists");
		mMapData.insert(std::make_pair(data.mBuffID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Odds2_HitCoefficient Loaded. Load Data:%u", mMapData.size());
}

void Odds2_HitCoefficient::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Odds2_HitCoefficient");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Odds2_HitCoefficient");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Odds2_HitCoefficientData data;
		LuaCfgHelper::readInt(L, "BuffID", data.mBuffID);
		LuaCfgHelper::readInt(L, "CaptureNumber", data.mCaptureNumber);
		LuaCfgHelper::readInt(L, "BuffEffectMin", data.mBuffEffectMin);
		LuaCfgHelper::readVectorInt(L, "BossId", data.mBossId);
		if (mMapData.find(data.mBuffID) != mMapData.end())std::cout <<"data refind:" << data.mBuffID << std::endl;
		CCASSERT(mMapData.find(data.mBuffID) == mMapData.end(), "data.mBuffID is exists");
		mMapData.insert(std::make_pair(data.mBuffID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Odds2_HitCoefficient Loaded. Load Data:%u", mMapData.size());
}

void Odds2_HitCoefficient::Reload()
{
	mMapData.clear();
	Load();
}

Odds2_HitCoefficient* Odds2_HitCoefficient::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Odds2_HitCoefficient());
	}
	return msSingleton.get();
}

void Odds2_HitCoefficient::Release()
{
	msSingleton.reset(nullptr);
}
